# Enum VertexAttribute.Usage

java.lang.Object
java.lang.Enum<VertexAttribute.Usage>
com.codename1.gpu.VertexAttribute.Usage

All Implemented Interfaces:
  `Comparable<VertexAttribute.Usage>`

Enclosing class:
  `VertexAttribute`

public static enum VertexAttribute.Usage extends Enum<VertexAttribute.Usage>
The semantic meaning of a vertex attribute. The engine binds each usage to a known shader input and a known purpose in the generated materials.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `COLOR`
  Per vertex color.
  `NORMAL`
  Object space vertex normal.
  `POSITION`
  Object space vertex position.
  `TEXCOORD`
  Primary texture coordinate.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VertexAttribute.Usage`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static VertexAttribute.Usage[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, equals, getDeclaringClass, getEnumValues, hashCode, name, ordinal, setEnumValues, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### POSITION

    public static final VertexAttribute.Usage POSITION
    Object space vertex position. Typically 3 float components.

  - ### NORMAL

    public static final VertexAttribute.Usage NORMAL
    Object space vertex normal. Typically 3 float components.

  - ### TEXCOORD

    public static final VertexAttribute.Usage TEXCOORD
    Primary texture coordinate. Typically 2 float components.

  - ### COLOR

    public static final VertexAttribute.Usage COLOR
    Per vertex color. Typically 4 components.

- ## Method Details

  - ### values

    public static VertexAttribute.Usage[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static VertexAttribute.Usage valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null